package fwadmin;

/*

  JFwadmin v 0.8

  Copyright (C) 1999-2000 Mickael Feledyn
  		     mickael.feledyn@cybergal.com

  This application is free software; you can redistribute it and/or
  modify it under the terms of the GNU Genereal Public License as
  published by the Free Software Foundation; either version 2 of
  the License, or (at your option) any later version.

  This application is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU General Public License for more details.

*/

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.*;

public class AddAntiSpoofingServiceDialog extends JDialog implements ActionListener
{
  JPanel panel1 = new JPanel();
  JComboBox interfaceToProtectJComboBox = new JComboBox();
  JLabel interfaceToProtectJLabel = new JLabel();
  JButton okJButton = new JButton();
  JButton cancelJButton = new JButton();
  private boolean okPressed = false;
  JComboBox interfaceSpoofedNetworkJComboBox = new JComboBox();
  JLabel interfaceSpoofedNetworkJLabel = new JLabel();
  JCheckBox loggingjCheckBox = new JCheckBox();

  public AddAntiSpoofingServiceDialog(Frame frame, String title, boolean modal)
  {
	super(frame, title, modal);
	try
	{
	  jbInit();
	  for(Enumeration e = IPInterface.interfacesHashtable.elements(); e.hasMoreElements(); )
	  {
		IPInterface ipi = (IPInterface)e.nextElement();
		interfaceToProtectJComboBox.addItem(ipi.getName() + " (" + ipi.getKind() + ")");
		if (ipi.getKind().equals(IPFWConstants.networkKindInternet)) interfaceToProtectJComboBox.setSelectedItem(ipi.getName() + " (" + ipi.getKind() + ")");
		interfaceSpoofedNetworkJComboBox.addItem(ipi.getName() + " (" + ipi.getKind() + ")");
		if (! ipi.getKind().equals(IPFWConstants.networkKindInternet)) interfaceSpoofedNetworkJComboBox.setSelectedItem(ipi.getName() + " (" + ipi.getKind() + ")");
	  }

	  cancelJButton.addActionListener(this);
	  okJButton.addActionListener(this);
	  loggingjCheckBox.setSelected(false);
	  pack();
	}
	catch(Exception ex)
	{
	  ex.printStackTrace();
	}
  }            
  public void actionPerformed(ActionEvent e)
  {
	if(e.getSource() == cancelJButton)
	{
	  dispose();
	}
	if(e.getSource() == okJButton)
	{
	  String selectedIFToProtect = (String) interfaceToProtectJComboBox.getSelectedItem();
	  StringTokenizer stToProtect = new StringTokenizer(selectedIFToProtect, " ");
	  String ifNameToProtect = stToProtect.nextToken();
	  String selectedIFSpoofedNetwork = (String) interfaceSpoofedNetworkJComboBox.getSelectedItem();
	  StringTokenizer stSpoofedNetwork = new StringTokenizer(selectedIFSpoofedNetwork, " ");
	  String ifNameSpoofedNetwork = stSpoofedNetwork.nextToken();

	  InputRule ir = new InputRule();
	  ir.m_ruleType = "input";
	  ir.m_sourceAddress = new IPAddress(IPInterface.getInterface(ifNameSpoofedNetwork).getAddress().getLong() & IPInterface.getInterface(ifNameSpoofedNetwork).getMask().getLong());
	  ir.m_sourceMask = new IPMask(IPInterface.getInterface(ifNameSpoofedNetwork).getMask().getLong());
	  ir.m_destinationAddress = new IPAddress(0L);
	  ir.m_destinationMask = new IPMask(0L);
	  ir.m_sourceLowPort = 0;
	  ir.m_sourceHighPort = 65535;
	  ir.m_destinationLowPort = 0;
	  ir.m_destinationHighPort = 65535;
	  ir.m_interfaceName = ifNameToProtect;
	  ir.m_policy = DefaultPolicy.firewallDenyPolicy;
	  ir.m_protocol = Linux22.IPPROTO_IP;
	  OutputRule or = new OutputRule();
	  or.m_ruleType = "output";
	  or.m_sourceAddress = ir.m_destinationAddress;
	  or.m_sourceMask = ir.m_destinationMask;
	  or.m_destinationAddress = ir.m_sourceAddress;
	  or.m_destinationMask = ir.m_sourceMask;
	  or.m_interfaceName = ir.m_interfaceName;
	  or.m_policy = ir.m_policy;
	  or.m_protocol = ir.m_protocol;
	  or.m_sourceLowPort = ir.m_destinationLowPort;
	  or.m_sourceHighPort = ir.m_destinationHighPort;
	  or.m_destinationLowPort = ir.m_sourceLowPort;
	  or.m_destinationHighPort = ir.m_sourceHighPort;

	  ir.m_ruleDirtySectionOrdering = Linux22.DIRTY_ORDERING_SECTION_1_BASE + Linux22.m_ruleDirtyNumber;
	  or.m_ruleDirtySectionOrdering = Linux22.DIRTY_ORDERING_SECTION_1_BASE + Linux22.m_ruleDirtyNumber++;
	  if (loggingjCheckBox.isSelected())
	  {
		ir.m_flags |= Linux22.FLAG_LOGGING;
		or.m_flags |= Linux22.FLAG_LOGGING;
	  }

	  InputService.inputServicesVector.addElement(new InputService(ir, or, "not applied"));
	  InputRule.inputRulesVector.addElement(ir);
	  OutputRule.outputRulesVector.addElement(or);

	  okPressed = true;
	  dispose();
	}
  }          
  public boolean getOK()
  {
	return okPressed;
  }  
  void jbInit() throws Exception
  {
	panel1.setLayout(null);
	interfaceToProtectJComboBox.setBounds(new Rectangle(21, 37, 205, 29));
	interfaceToProtectJLabel.setText("Interface to protect");
	interfaceToProtectJLabel.setBounds(new Rectangle(16, 12, 205, 24));
	interfaceSpoofedNetworkJLabel.setText("Spoofed network interface ");
	interfaceSpoofedNetworkJLabel.setBounds(new Rectangle(16, 72, 320, 24));
	interfaceSpoofedNetworkJComboBox.setBounds(new Rectangle(21, 93, 205, 29));
	okJButton.setText("OK");
	okJButton.setBounds(new Rectangle(32, 204, 113, 32));
	cancelJButton.setText("Cancel");
	cancelJButton.setBounds(new Rectangle(155, 204, 115, 34));
	panel1.setMinimumSize(new Dimension(320, 250));
	panel1.setPreferredSize(new Dimension(320, 250));
	loggingjCheckBox.setText("Activate logging");
	loggingjCheckBox.setBounds(new Rectangle(77, 150, 174, 30));
	getContentPane().add(panel1);
	panel1.add(interfaceToProtectJComboBox, null);
	panel1.add(interfaceSpoofedNetworkJComboBox, null);
	panel1.add(interfaceToProtectJLabel, null);
	panel1.add(interfaceSpoofedNetworkJLabel, null);
	panel1.add(okJButton, null);
	panel1.add(cancelJButton, null);
	panel1.add(loggingjCheckBox, null);


  	panel1.setFont(JFwadmin.m_font);
  	interfaceToProtectJComboBox.setFont(JFwadmin.m_font);
  	interfaceToProtectJLabel.setFont(JFwadmin.m_font);
  	okJButton.setFont(JFwadmin.m_font);
  	cancelJButton.setFont(JFwadmin.m_font);
  	interfaceSpoofedNetworkJComboBox.setFont(JFwadmin.m_font);
  	interfaceSpoofedNetworkJLabel.setFont(JFwadmin.m_font);
  	loggingjCheckBox.setFont(JFwadmin.m_font);
  }        
  public void resetOK()
  {
	okPressed = false;
  }  
}
