package fwadmin;

/*

  JFwadmin v 0.8

  Copyright (C) 1999-2000 Mickael Feledyn
  		     mickael.feledyn@cybergal.com

  This application is free software; you can redistribute it and/or
  modify it under the terms of the GNU Genereal Public License as
  published by the Free Software Foundation; either version 2 of
  the License, or (at your option) any later version.

  This application is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU General Public License for more details.

*/

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.*;

public class AddForwardServiceDialog extends JDialog implements ActionListener, ItemListener
{
  IPAddress dest_ipaddr;
  IPMask dest_netmask;
  IPAddress src_ipaddr;
  IPMask src_netmask;
  
  JPanel panel1 = new JPanel();
  JComboBox interfaceFromJComboBox = new JComboBox();
  JLabel interfaceFromJLabel = new JLabel();
  JRadioButton serviceJRadioButton = new JRadioButton();
  JRadioButton portRangeJRadioButton = new JRadioButton();
  JComboBox serviceJComboBox = null;
  JTextField portRangeLowTextField = new JTextField();
  JLabel lowPortRangeJLabel = new JLabel();
  JLabel portRangeHighJLabel = new JLabel();
  JTextField portRangeHighJTextField = new JTextField();
  JComboBox policyJComboBox = new JComboBox();
  JLabel policyJLabel = new JLabel();
  JButton okJButton = new JButton();
  JButton cancelJButton = new JButton();
  JLabel protocolJLabel = new JLabel();
  JComboBox protocolJComboBox = new JComboBox();
  private boolean okPressed = false;
  JComboBox interfaceToJComboBox = new JComboBox();
  JLabel interfaceToJLabel = new JLabel();
  JCheckBox dest_specifyIPNetJCheckBox = new JCheckBox();
  JCheckBox src_specifyIPNetJCheckBox = new JCheckBox();
  public AddForwardServiceDialog(Frame frame, String title, boolean modal)
  {
	super(frame, title, modal);
	try
	{
	  jbInit();
	  for(Enumeration e = IPInterface.interfacesHashtable.elements(); e.hasMoreElements(); )
	  {
		IPInterface ipi = (IPInterface)e.nextElement();
		interfaceFromJComboBox.addItem(ipi.getName() + " (" + ipi.getKind() + ")");
		interfaceToJComboBox.addItem(ipi.getName() + " (" + ipi.getKind() + ")");
	  }

	  ButtonGroup radioGroup = new ButtonGroup();
	  radioGroup.add(serviceJRadioButton);
	  radioGroup.add(portRangeJRadioButton);
	  serviceJRadioButton.addActionListener(this);
	  portRangeJRadioButton.addActionListener(this);
	  cancelJButton.addActionListener(this);
	  okJButton.addActionListener(this);
	  src_specifyIPNetJCheckBox.addItemListener(this);
	  dest_specifyIPNetJCheckBox.addItemListener(this);
	  src_specifyIPNetJCheckBox.setToolTipText("For specific needs");
	  dest_specifyIPNetJCheckBox.setToolTipText("For specific needs");
	  portRangeLowTextField.setEnabled(false);
	  lowPortRangeJLabel.setEnabled(false);
	  portRangeHighJLabel.setEnabled(false);
	  portRangeHighJTextField.setEnabled(false);
	  policyJComboBox.addItem(DefaultPolicy.firewallMasqPolicy);
	  policyJComboBox.addItem(DefaultPolicy.firewallForwardPolicy);
	  policyJComboBox.addItem(DefaultPolicy.firewallAcceptPolicy);
	  policyJComboBox.addItem(DefaultPolicy.firewallDenyPolicy);
	  protocolJComboBox.addItem("tcp");
	  protocolJComboBox.addItem("udp");
	  protocolJComboBox.addItem("icmp");
	  protocolJComboBox.addItem("all");
	  pack();
	}
	catch(Exception ex)
	{
	  ex.printStackTrace();
	}
  }      
  public void actionPerformed(ActionEvent e)
  {
	if(e.getSource() == serviceJRadioButton)
	{
	  portRangeLowTextField.setEnabled(false);
	  lowPortRangeJLabel.setEnabled(false);
	  portRangeHighJLabel.setEnabled(false);
	  portRangeHighJTextField.setEnabled(false);
	  serviceJComboBox.setEnabled(true);
	}
	if(e.getSource() == portRangeJRadioButton)
	{
	  portRangeLowTextField.setEnabled(true);
	  lowPortRangeJLabel.setEnabled(true);
	  portRangeHighJLabel.setEnabled(true);
	  portRangeHighJTextField.setEnabled(true);
	  serviceJComboBox.setEnabled(false);
	}
	if(e.getSource() == cancelJButton)
	{
	  dispose();
	}
	if(e.getSource() == okJButton)
	{
		ForwardRule fr = new ForwardRule();
		try
		{
		  String selectedIFTo = (String) interfaceToJComboBox.getSelectedItem();
		  StringTokenizer stTo = new StringTokenizer(selectedIFTo, " ");
		  String ifNameTo = stTo.nextToken();
		  String selectedIFFrom = (String) interfaceFromJComboBox.getSelectedItem();
		  StringTokenizer stFrom = new StringTokenizer(selectedIFFrom, " ");
		  String ifNameFrom = stFrom.nextToken();
		  fr.m_ruleType = "forward";
		  if (IPInterface.getInterface(ifNameFrom).getKind().equals(IPFWConstants.networkKindInternet))
		  {
			StringTokenizer st = new StringTokenizer(JFwadmin.getResource("anywhere_network"), "/");
			IPAddress ip = new IPAddress(0L);
			try{ip.fromString(st.nextToken());}catch(Exception bad1){}
			IPMask mk = new IPMask(0L);
			try{ip.fromString(st.nextToken());}catch(Exception bad2){}
			fr.m_sourceAddress = ip;
			fr.m_sourceMask = mk;
		  }
		  else
		  {
			fr.m_sourceAddress = new IPAddress(IPInterface.getInterface(ifNameFrom).getAddress().getLong() & IPInterface.getInterface(ifNameFrom).getMask().getLong());
			fr.m_sourceMask = new IPMask(IPInterface.getInterface(ifNameFrom).getMask().getLong());
		  }
		  if (src_specifyIPNetJCheckBox.isSelected())
		  {
			fr.m_sourceAddress = src_ipaddr;
			fr.m_sourceMask = src_netmask;
		  }
		  if (IPInterface.getInterface(ifNameTo).getKind().equals(IPFWConstants.networkKindInternet))
		  {
			StringTokenizer st = new StringTokenizer(JFwadmin.getResource("anywhere_network"), "/");
			IPAddress ip = new IPAddress(0L);
			try{ip.fromString(st.nextToken());}catch(Exception bad1){}
			IPMask mk = new IPMask(0L);
			try{ip.fromString(st.nextToken());}catch(Exception bad2){}
			fr.m_destinationAddress = ip;
			fr.m_destinationMask = mk;
		  }
		  else
		  {
			fr.m_destinationAddress = new IPAddress(IPInterface.getInterface(ifNameTo).getAddress().getLong() & IPInterface.getInterface(ifNameTo).getMask().getLong());
			fr.m_destinationMask = new IPMask(IPInterface.getInterface(ifNameTo).getMask().getLong());
		  }
		  if (dest_specifyIPNetJCheckBox.isSelected())
		  {
			fr.m_destinationAddress = dest_ipaddr;
			fr.m_destinationMask = dest_netmask;
		  }
		  try
		  {
			StringTokenizer st2 = new StringTokenizer(JFwadmin.getResource("any_port"), ":");
			fr.m_sourceLowPort = Integer.parseInt(st2.nextToken());
			fr.m_sourceHighPort = Integer.parseInt(st2.nextToken());
		  }
		  catch(Exception e2)
		  {
			fr.m_sourceLowPort = 0;
			fr.m_sourceHighPort = 65535;
		  }	
		  if (serviceJRadioButton.isSelected())
		  {
			int portNumber = Linux22.getServicePortNumber((String)serviceJComboBox.getEditor().getItem(), (String)protocolJComboBox.getSelectedItem());
			if (portNumber == 0)
			{
			  JOptionPane.showMessageDialog(JFwadmin.getInstance(), "The selected service is not supported on " + (String)protocolJComboBox.getSelectedItem(), "Error", JOptionPane.ERROR_MESSAGE);
			  return;
			}
			fr.m_destinationLowPort = portNumber;
			fr.m_destinationHighPort = portNumber;
		  }
		  else
		  {
			fr.m_destinationLowPort = Integer.parseInt(portRangeLowTextField.getText());
			fr.m_destinationHighPort = Integer.parseInt(portRangeHighJTextField.getText());
		  }
		  fr.m_interfaceName = ifNameTo;
		  fr.m_policy = (String) policyJComboBox.getSelectedItem();
		  fr.m_protocol = Linux22.getProtocolConstant((String)protocolJComboBox.getSelectedItem());

		  fr.m_ruleDirtySectionOrdering = Linux22.DIRTY_ORDERING_SECTION_2_BASE + Linux22.m_ruleDirtyNumber++;
	  }
	  catch(Exception e2)
	  {
		JOptionPane.showMessageDialog(this, "Please verify your inputs", "Errors in parameters", JOptionPane.WARNING_MESSAGE);
		return;
	  }
	  ForwardRule.forwardRulesVector.addElement(fr);

	  okPressed = true;
	  dispose();
	}
  }                      
  public boolean getOK()
  {
	return okPressed;
  }  
public void itemStateChanged(ItemEvent e)
{
	if(e.getStateChange() == ItemEvent.SELECTED)
	if(isVisible())
	{
		if(e.getSource() == src_specifyIPNetJCheckBox)
		{
		  src_ipaddr = new IPAddress();
		  src_netmask = new IPMask();
		  IPNetDialog ipNetDlg = new IPNetDialog(this, "Specify source address", true, src_ipaddr, src_netmask, src_specifyIPNetJCheckBox);
		  ipNetDlg.setVisible(true);
		}
		if(e.getSource() == dest_specifyIPNetJCheckBox)
		{
		  dest_ipaddr = new IPAddress();
		  dest_netmask = new IPMask();
		  IPNetDialog ipNetDlg = new IPNetDialog(this, "Specify destination address", true, dest_ipaddr, dest_netmask, dest_specifyIPNetJCheckBox);
		  ipNetDlg.setVisible(true);
		}
	}
}
  void jbInit() throws Exception
  {
	panel1.setLayout(null);
	interfaceFromJComboBox.setBounds(new Rectangle(21, 37, 205, 29));
	interfaceFromJLabel.setText("Interface to relay from");
	interfaceFromJLabel.setBounds(new Rectangle(16, 12, 205, 24));
	interfaceToJLabel.setText("Interface to forward to");
	interfaceToJLabel.setBounds(new Rectangle(16, 72, 205, 24));
	interfaceToJComboBox.setBounds(new Rectangle(21, 93, 205, 29));
	serviceJRadioButton.setSelected(true);
	serviceJRadioButton.setText("Service / port");
	serviceJRadioButton.setBounds(new Rectangle(20, 142, 172, 29));
	portRangeJRadioButton.setText("Ports range");
	portRangeJRadioButton.setBounds(new Rectangle(21, 226, 154, 24));
	serviceJComboBox = new JComboBox(Linux22.servicesVector);
	serviceJComboBox.setEditable(true);
	serviceJComboBox.setBounds(new Rectangle(43, 178, 196, 28));
	portRangeLowTextField.setBounds(new Rectangle(120, 258, 127, 26));
	lowPortRangeJLabel.setText("Low port");
	lowPortRangeJLabel.setBounds(new Rectangle(27, 260, 82, 24));
	portRangeHighJLabel.setText("High port");
	portRangeHighJLabel.setBounds(new Rectangle(265, 257, 79, 27));
	portRangeHighJTextField.setBounds(new Rectangle(348, 257, 123, 28));
	policyJComboBox.setBounds(new Rectangle(244, 37, 130, 29));
	policyJLabel.setText("Policy");
	policyJLabel.setBounds(new Rectangle(241, 15, 124, 23));
	okJButton.setText("OK");
	okJButton.setBounds(new Rectangle(119, 325, 113, 32));
	cancelJButton.setText("Cancel");
	cancelJButton.setBounds(new Rectangle(255, 325, 115, 34));
	src_specifyIPNetJCheckBox.setText("Specify source network");
	src_specifyIPNetJCheckBox.setBounds(new Rectangle(285, 80, 202, 33));
	dest_specifyIPNetJCheckBox.setText("Specify destination network");
	dest_specifyIPNetJCheckBox.setBounds(new Rectangle(285, 122, 202, 33));
	panel1.setMinimumSize(new Dimension(500, 370));
	panel1.setPreferredSize(new Dimension(500, 370));
	protocolJLabel.setText("Protocol");
	protocolJLabel.setBounds(new Rectangle(387, 16, 85, 22));
	protocolJComboBox.setBounds(new Rectangle(391, 37, 88, 29));
	getContentPane().add(panel1);
	panel1.add(interfaceFromJComboBox, null);
	panel1.add(protocolJComboBox, null);
	panel1.add(protocolJLabel, null);
	panel1.add(policyJComboBox, null);
	panel1.add(policyJLabel, null);
	panel1.add(cancelJButton, null);
	panel1.add(serviceJRadioButton, null);
	panel1.add(serviceJComboBox, null);
	panel1.add(portRangeJRadioButton, null);
	panel1.add(lowPortRangeJLabel, null);
	panel1.add(portRangeLowTextField, null);
	panel1.add(portRangeHighJLabel, null);
	panel1.add(portRangeHighJTextField, null);
	panel1.add(okJButton, null);
	panel1.add(interfaceToJComboBox, null);
	panel1.add(interfaceToJLabel, null);
	panel1.add(interfaceFromJLabel, null);
	panel1.add(src_specifyIPNetJCheckBox, null);
	panel1.add(dest_specifyIPNetJCheckBox, null);

	try
	{
		StringTokenizer st = new StringTokenizer(JFwadmin.getResource("any_port"), ":");
		portRangeLowTextField.setText(st.nextToken());
		portRangeHighJTextField.setText(st.nextToken());
	}
	catch(Exception e)
	{
		portRangeHighJTextField.setText("65535");
		portRangeLowTextField.setText("0");
	}	
  }            
  public void resetOK()
  {
	okPressed = false;
  }  
}
