package fwadmin;

/*

  JFwadmin v 0.8

  Copyright (C) 1999-2000 Mickael Feledyn
  		     mickael.feledyn@cybergal.com

  This application is free software; you can redistribute it and/or
  modify it under the terms of the GNU Genereal Public License as
  published by the Free Software Foundation; either version 2 of
  the License, or (at your option) any later version.

  This application is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU General Public License for more details.

*/

import java.util.*;

public class IPInterface
{
  public static Hashtable interfacesHashtable = new Hashtable();
  private Vector routesVector = new Vector();

  private String m_name;
  private String m_kind;
  private IPAddress m_ipAddress;
  private IPMask m_ipMask;
  public IPInterface(String name, String addr, String mask)
  {
	m_name = name;
	// try to guess interface type.
	setKind(IPFWConstants.networkKindLocalNetwork);
	if(m_name.startsWith("lo")) setKind(IPFWConstants.networkKindLocalLoopback);

	StringTokenizer st = new StringTokenizer(addr, ".");
	long laddr = 0L;
	while(st.hasMoreTokens())
	{
	  laddr = (laddr * 0x100) + Long.parseLong(st.nextToken());
	}
	m_ipAddress = new IPAddress(laddr);

	StringTokenizer st2 = new StringTokenizer(mask, ".");
	long lmask = 0L;
	while(st2.hasMoreTokens())
	{
	  lmask = (lmask * 0x100) + Long.parseLong(st2.nextToken());
	}
	m_ipMask = new IPMask(lmask);

	interfacesHashtable.put(m_name, this);
	//System.out.println(toString());
  }  
public void addRoute(String destination, String gateway, String genmask)
{
  Route newRoute = new Route(destination, gateway, genmask);
  if (destination.compareTo("00000000") == 0) setKind(IPFWConstants.networkKindInternet);
  routesVector.addElement(newRoute);
}
  public boolean equals(IPInterface other)
  {
	return getName().equals(other.getName());
  }  
  public IPAddress getAddress()
  {
	return m_ipAddress;
  }  
public static IPInterface getInterface(String if_name)
{
	return (IPInterface)interfacesHashtable.get(if_name);
}
  public String getKind()
  {
	return m_kind;
  }  
  public IPMask getMask()
  {
	return m_ipMask;
  }  
  public String getName()
  {
	return m_name;
  }  
  public Vector getRoutes()
  {
	return routesVector;
  }  
public String routesToString()
{
  String res = "";
  for (int i=0; i < routesVector.size(); i++)
  {
	res += ((Route)routesVector.elementAt(i)).toString();
  }
  return res;
}
  public void setKind(String kind)
  {
	m_kind = kind;
  }  
public String toString()
{
  String res = "  IF_NAME : " + m_name;
	res += " IF_ADDR : " + m_ipAddress.toString();
	res += " IF_MASK : " + m_ipMask.toString();

  return res;
}
}
