package fwadmin;

/*

  JFwadmin v 0.8

  Copyright (C) 1999-2000 Mickael Feledyn
  		     mickael.feledyn@cybergal.com

  This application is free software; you can redistribute it and/or
  modify it under the terms of the GNU Genereal Public License as
  published by the Free Software Foundation; either version 2 of
  the License, or (at your option) any later version.

  This application is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU General Public License for more details.

*/

public class IPMask
{
  public static final String MASQ_4x255 = "255.255.255.255";
  private long m_mask;

  public IPMask()
  {
	m_mask = 0L;
  }    
  public IPMask(long mask)
  {
	m_mask = mask;
  }  
  public boolean equals(IPMask other)
  {
	return getLong() == other.getLong();
  }  
  public void fromString(String ipMask) throws Exception
  {
	  java.util.StringTokenizer st = new java.util.StringTokenizer(ipMask, ".");//$NON-NLS-1$
	  long lip = 0L;
	  for (int i=0; i < 4; i++)
	  {
		  lip *= 256;
		  lip += Integer.parseInt(st.nextToken());
	  }
	  m_mask = lip;
  }              
  public long getLong()
  {
	return m_mask;
  }  
  public String getMaskStringForScript()
  {
	if (toString().equals(MASQ_4x255)) return "";//$NON-NLS-1$

	return ("/" + toString());//$NON-NLS-1$
  }    
  public String toString()
  {
	  String res = ("" + (m_mask / (256*256*256)) % 256 + ".");//$NON-NLS-2$//$NON-NLS-1$
	  res += ("" + (m_mask / (256*256)) % 256 + ".");//$NON-NLS-2$//$NON-NLS-1$
	  res += ("" + (m_mask / (256)) % 256 + ".");//$NON-NLS-2$//$NON-NLS-1$
	  res += ("" + (m_mask) % 256);//$NON-NLS-1$
	return res;
  }    
}
